diff -ruN qmail-1.03-orig/instcheck.c qmail-1.03-ldap-20060201-orig/instcheck.c
--- qmail-1.03-orig/instcheck.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/instcheck.c	2006-02-25 11:00:55.000000000 +0100
@@ -1,5 +1,6 @@
 #include <sys/types.h>
 #include <sys/stat.h>
+#include <unistd.h>
 #include "strerr.h"
 #include "error.h"
 #include "readwrite.h"
@@ -11,14 +12,14 @@
 #define WARNING "instcheck: warning: "
 
 void perm(prefix1,prefix2,prefix3,file,type,uid,gid,mode)
-char *prefix1;
-char *prefix2;
-char *prefix3;
-char *file;
-int type;
+const char *prefix1;
+const char *prefix2;
+const char *prefix3;
+const char *file;
+unsigned int type;
 int uid;
 int gid;
-int mode;
+unsigned int mode;
 {
   struct stat st;
 
@@ -30,9 +31,9 @@
     return;
   }
 
-  if ((uid != -1) && (st.st_uid != uid))
+  if ((uid != -1) && (st.st_uid != (unsigned int)uid))
     strerr_warn6(WARNING,prefix1,prefix2,prefix3,file," has wrong owner",0);
-  if ((gid != -1) && (st.st_gid != gid))
+  if ((gid != -1) && (st.st_gid != (unsigned int)gid))
     strerr_warn6(WARNING,prefix1,prefix2,prefix3,file," has wrong group",0);
   if ((st.st_mode & 07777) != mode)
     strerr_warn6(WARNING,prefix1,prefix2,prefix3,file," has wrong permissions",0);
@@ -41,7 +42,7 @@
 }
 
 void h(home,uid,gid,mode)
-char *home;
+const char *home;
 int uid;
 int gid;
 int mode;
@@ -50,8 +51,8 @@
 }
 
 void d(home,subdir,uid,gid,mode)
-char *home;
-char *subdir;
+const char *home;
+const char *subdir;
 int uid;
 int gid;
 int mode;
@@ -62,8 +63,8 @@
 }
 
 void p(home,fifo,uid,gid,mode)
-char *home;
-char *fifo;
+const char *home;
+const char *fifo;
 int uid;
 int gid;
 int mode;
@@ -74,9 +75,25 @@
 }
 
 void c(home,subdir,file,uid,gid,mode)
-char *home;
-char *subdir;
-char *file;
+const char *home;
+const char *subdir;
+const char *file;
+int uid;
+int gid;
+int mode;
+{
+  if (chdir(home) == -1)
+    strerr_die4sys(111,FATAL,"unable to switch to ",home,": ");
+  if (chdir(subdir) == -1)
+    strerr_die6sys(111,FATAL,"unable to switch to ",home,"/",subdir,": ");
+  perm(".../",subdir,"/",file,S_IFREG,uid,gid,mode);
+}
+
+void C(home,subdir,file,source,uid,gid,mode)
+const char *home;
+const char *subdir;
+const char *file;
+const char *source;
 int uid;
 int gid;
 int mode;
@@ -89,8 +106,8 @@
 }
 
 void z(home,file,len,uid,gid,mode)
-char *home;
-char *file;
+const char *home;
+const char *file;
 int len;
 int uid;
 int gid;
@@ -101,8 +118,24 @@
   perm("",home,"/",file,S_IFREG,uid,gid,mode);
 }
 
-void main()
+void l(home,subdir,logdir,loguser,uid,gid,mode)
+const char *home;
+const char *subdir;
+const char *logdir;
+const char *loguser;
+int uid;
+int gid;
+int mode;
+{
+  if (chdir(home) == -1)
+    strerr_die4sys(111,FATAL,"unable to switch to ",home,": ");
+  if (chdir(subdir) == -1)
+    strerr_die6sys(111,FATAL,"unable to switch to ",home,"/",subdir,": ");
+  perm(".../",subdir,"/","run",S_IFREG,uid,gid,mode);
+}
+
+int main()
 {
   hier();
-  _exit(0);
+  return 0;
 }
diff -ruN qmail-1.03-orig/ipalloc.h qmail-1.03-ldap-20060201-orig/ipalloc.h
--- qmail-1.03-orig/ipalloc.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/ipalloc.h	2006-02-25 11:00:55.000000000 +0100
@@ -8,7 +8,7 @@
 #include "gen_alloc.h"
 
 GEN_ALLOC_typedef(ipalloc,struct ip_mx,ix,len,a)
-extern int ipalloc_readyplus();
-extern int ipalloc_append();
+extern int ipalloc_readyplus(ipalloc *, unsigned int);
+extern int ipalloc_append(ipalloc *, struct ip_mx *);
 
 #endif
diff -ruN qmail-1.03-orig/ip.c qmail-1.03-ldap-20060201-orig/ip.c
--- qmail-1.03-orig/ip.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/ip.c	2006-02-25 11:00:55.000000000 +0100
@@ -21,26 +21,42 @@
 }
 
 unsigned int ip_scan(s,ip)
-char *s;
+const char *s;
 struct ip_address *ip;
 {
   unsigned int i;
   unsigned int len;
   unsigned long u;
- 
+
+  /*
+   * Don't play games. everything over 255 is invalid and we need a full
+   * IP address. No magic expands like 127.1 or similar bullshit.
+   */
   len = 0;
-  i = scan_ulong(s,&u); if (!i) return 0; ip->d[0] = u; s += i; len += i;
+  i = scan_ulong(s,&u);
+  if (!i || u > 255) return 0;
+  ip->d[0] = u; s += i; len += i;
+
   if (*s != '.') return 0; ++s; ++len;
-  i = scan_ulong(s,&u); if (!i) return 0; ip->d[1] = u; s += i; len += i;
+  i = scan_ulong(s,&u);
+  if (!i || u > 255) return 0;
+  ip->d[1] = u; s += i; len += i;
+
   if (*s != '.') return 0; ++s; ++len;
-  i = scan_ulong(s,&u); if (!i) return 0; ip->d[2] = u; s += i; len += i;
+  i = scan_ulong(s,&u);
+  if (!i || u > 255) return 0;
+  ip->d[2] = u; s += i; len += i;
+
   if (*s != '.') return 0; ++s; ++len;
-  i = scan_ulong(s,&u); if (!i) return 0; ip->d[3] = u; s += i; len += i;
+  i = scan_ulong(s,&u);
+  if (!i || u > 255) return 0;
+  ip->d[3] = u; s += i; len += i;
+
   return len;
 }
 
 unsigned int ip_scanbracket(s,ip)
-char *s;
+const char *s;
 struct ip_address *ip;
 {
   unsigned int len;
diff -ruN qmail-1.03-orig/ip.h qmail-1.03-ldap-20060201-orig/ip.h
--- qmail-1.03-orig/ip.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/ip.h	2006-02-25 11:00:55.000000000 +0100
@@ -3,9 +3,9 @@
 
 struct ip_address { unsigned char d[4]; } ;
 
-extern unsigned int ip_fmt();
+extern unsigned int ip_fmt(char *, struct ip_address *);
 #define IPFMT 19
-extern unsigned int ip_scan();
-extern unsigned int ip_scanbracket();
+extern unsigned int ip_scan(const char *, struct ip_address *);
+extern unsigned int ip_scanbracket(const char *, struct ip_address *);
 
 #endif
diff -ruN qmail-1.03-orig/ipme.c qmail-1.03-ldap-20060201-orig/ipme.c
--- qmail-1.03-orig/ipme.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/ipme.c	2006-02-25 11:00:55.000000000 +0100
@@ -8,6 +8,7 @@
 #ifndef SIOCGIFCONF /* whatever works */
 #include <sys/sockio.h>
 #endif
+#include <unistd.h>
 #include "hassalen.h"
 #include "byte.h"
 #include "ip.h"
@@ -21,7 +22,7 @@
 int ipme_is(ip)
 struct ip_address *ip;
 {
-  int i;
+  unsigned int i;
   if (ipme_init() != 1) return -1;
   for (i = 0;i < ipme.len;++i)
     if (byte_equal(&ipme.ix[i].ip,4,ip))
@@ -36,8 +37,8 @@
   struct ifconf ifc;
   char *x;
   struct ifreq *ifr;
-  struct sockaddr_in *sin;
-  int len;
+  struct sockaddr_in *s_in;
+  unsigned int len;
   int s;
   struct ip_mx ix;
  
@@ -45,6 +46,12 @@
   if (!ipalloc_readyplus(&ipme,0)) return 0;
   ipme.len = 0;
   ix.pref = 0;
+
+  /* 0.0.0.0 is a special address which always refers to 
+   * "this host, this network", according to RFC 1122, Sec. 3.2.1.3a.
+   */
+  byte_copy(&ix.ip,4,"\0\0\0\0");
+  if (!ipalloc_append(&ipme,&ix)) { return 0; }
  
   if ((s = socket(AF_INET,SOCK_STREAM,0)) == -1) return -1;
  
@@ -70,8 +77,8 @@
     if (len < sizeof(*ifr))
       len = sizeof(*ifr);
     if (ifr->ifr_addr.sa_family == AF_INET) {
-      sin = (struct sockaddr_in *) &ifr->ifr_addr;
-      byte_copy(&ix.ip,4,&sin->sin_addr);
+      s_in = (struct sockaddr_in *) &ifr->ifr_addr;
+      byte_copy(&ix.ip,4,&s_in->sin_addr);
       if (ioctl(s,SIOCGIFFLAGS,x) == 0)
         if (ifr->ifr_flags & IFF_UP)
           if (!ipalloc_append(&ipme,&ix)) { close(s); return 0; }
@@ -82,8 +89,8 @@
       if (ifr->ifr_flags & IFF_UP)
         if (ioctl(s,SIOCGIFADDR,x) == 0)
 	  if (ifr->ifr_addr.sa_family == AF_INET) {
-	    sin = (struct sockaddr_in *) &ifr->ifr_addr;
-	    byte_copy(&ix.ip,4,&sin->sin_addr);
+	    s_in = (struct sockaddr_in *) &ifr->ifr_addr;
+	    byte_copy(&ix.ip,4,&s_in->sin_addr);
 	    if (!ipalloc_append(&ipme,&ix)) { close(s); return 0; }
 	  }
 #endif
diff -ruN qmail-1.03-orig/ipme.h qmail-1.03-ldap-20060201-orig/ipme.h
--- qmail-1.03-orig/ipme.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/ipme.h	2006-02-25 11:00:55.000000000 +0100
@@ -6,7 +6,7 @@
 
 extern ipalloc ipme;
 
-extern int ipme_init();
-extern int ipme_is();
+extern int ipme_init(void);
+extern int ipme_is(struct ip_address *);
 
 #endif
diff -ruN qmail-1.03-orig/ipmeprint.c qmail-1.03-ldap-20060201-orig/ipmeprint.c
--- qmail-1.03-orig/ipmeprint.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/ipmeprint.c	2006-02-25 11:00:55.000000000 +0100
@@ -6,9 +6,9 @@
 
 char temp[IPFMT];
 
-void main()
+int main(int argc, char **argv)
 {
- int j;
+ unsigned int j;
  switch(ipme_init())
   {
    case 0: substdio_putsflush(subfderr,"out of memory\n"); _exit(111);
@@ -20,5 +20,5 @@
    substdio_puts(subfdout,"\n");
   }
  substdio_flush(subfdout);
- _exit(0);
+ return 0;
 }
diff -ruN qmail-1.03-orig/LICENSE qmail-1.03-ldap-20060201-orig/LICENSE
--- qmail-1.03-orig/LICENSE	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/LICENSE	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,40 @@
+
+This copyright notice applies to the qmail-ldap patch. It does not apply
+to the original qmail-1.03 by Dan Bernstein. It also partly applies to
+the resulting source and object code. In that Dan Bernsteins copyright
+remains intact and is enhanced with ours as derivative work.
+
+/*
+ * Copyright (c) 1998-2004 Andre Oppermann, Claudio Jeker,
+ *      Internet Business Solutions AG, CH-8005 Zürich, Switzerland
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *      This product includes software developed by Internet Business
+ *      Solutions AG and its contributors.
+ * 4. Neither the name of the author nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+
diff -ruN qmail-1.03-orig/limit.h qmail-1.03-ldap-20060201-orig/limit.h
--- qmail-1.03-orig/limit.h	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/limit.h	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,22 @@
+#ifndef __LIMIT_H__
+#define __LIMIT_H__
+
+#include <limits.h>
+
+/* 
+ * we only need the max value for 32bit integers so make sure that we have
+ * those available.
+ * So we assume ILP32 or I32LP64 based systems which should be the default
+ * for unix systems. AFAIK only Cray is ILP64...
+ */
+#ifndef UINT_MAX
+#define UINT_MAX        0xffffffffU     /* max value for an unsigned int */
+#endif
+#ifndef INT_MAX
+#define INT_MAX         0x7fffffff      /* max value for an int */
+#endif
+#ifndef INT_MIN
+#define INT_MIN         (-0x7fffffff-1) /* min value for an int */
+#endif
+
+#endif
diff -ruN qmail-1.03-orig/localdelivery.c qmail-1.03-ldap-20060201-orig/localdelivery.c
--- qmail-1.03-orig/localdelivery.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/localdelivery.c	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,58 @@
+/*
+ * Copyright (c) 2003-2004 Claudio Jeker,
+ *      Internet Business Solutions AG, CH-8005 Zürich, Switzerland
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *      This product includes software developed by Internet Business
+ *      Solutions AG and its contributors.
+ * 4. Neither the name of the author nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+#include "control.h"
+#include "qldap-debug.h"
+
+#include "localdelivery.h"
+
+static int	flaglocaldelivery;
+
+int
+localdelivery_init(void)
+{
+	flaglocaldelivery = 1;	/* localdelivery is on (DEFAULT) */
+
+	if (control_readint(&flaglocaldelivery,
+		    "control/ldaplocaldelivery") == -1)
+		return -1;
+	logit(64, "init: control/ldaplocaldelivery: %i\n", flaglocaldelivery);
+	return 0;
+}
+
+int
+localdelivery(void)
+{
+	return flaglocaldelivery;
+}
+
diff -ruN qmail-1.03-orig/localdelivery.h qmail-1.03-ldap-20060201-orig/localdelivery.h
--- qmail-1.03-orig/localdelivery.h	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/localdelivery.h	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,43 @@
+/*
+ * Copyright (c) 2003-2004 Claudio Jeker,
+ *      Internet Business Solutions AG, CH-8005 Zürich, Switzerland
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *      This product includes software developed by Internet Business
+ *      Solutions AG and its contributors.
+ * 4. Neither the name of the author nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+#ifndef __LOCALDELIVERY_H__
+#define __LOCALDELIVERY_H__
+
+int localdelivery_init(void);
+
+/* returns true if localdelivery is on */
+int localdelivery(void);
+
+#endif
+
diff -ruN qmail-1.03-orig/locallookup.c qmail-1.03-ldap-20060201-orig/locallookup.c
--- qmail-1.03-orig/locallookup.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/locallookup.c	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,182 @@
+/*
+ * Copyright (c) 2003-2004 Claudio Jeker,
+ *      Internet Business Solutions AG, CH-8005 Zürich, Switzerland
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *      This product includes software developed by Internet Business
+ *      Solutions AG and its contributors.
+ * 4. Neither the name of the author nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+
+/*
+ * Based on D. J. Bernsteins checkpassword program.
+ */
+
+#include <sys/types.h>
+#include <unistd.h>
+#include "error.h"
+#include "getln.h"
+#include "localdelivery.h"
+#include "open.h"
+#include "passwd.h"
+#include "qldap-debug.h"
+#include "qldap-errno.h"
+#include "readwrite.h"
+#include "substdio.h"
+
+#include "checkpassword.h"
+#include "locallookup.h"
+
+/* Edit the first lines in the Makefile to enable local passwd lookups 
+ * and debug options.
+ * To use shadow passwords under Solaris, uncomment the 'SHADOWOPTS' line 
+ * in the Makefile.
+ * To use shadow passwords under Linux, uncomment the 'SHADOWOPTS' line and
+ * the 'SHADOWLIBS=-lshadow' line in the Makefile.
+ */
+#include <pwd.h>
+#ifdef PW_SHADOW
+#include <shadow.h>
+#endif
+#ifdef AIX
+#include <userpw.h>
+#endif
+
+int
+check_passwd(stralloc *login, stralloc *authdata,
+    struct credentials *c, int fast)
+{
+	int ret;
+	struct passwd *pw;
+#ifdef PW_SHADOW
+	struct spwd *spw;
+#endif
+#ifdef AIX
+	struct userpw *spw;
+#endif
+
+	if (localdelivery() == 0) return NOSUCH;
+
+	pw = getpwnam(login->s);
+	if (!pw) {
+		/* XXX: unfortunately getpwnam() hides temporary errors */
+		logit(32, "check_passwd: user %s not found in passwd db\n",
+		    login->s);
+		return NOSUCH;
+	}
+	logit(32, "check_passwd: user %s found in passwd db\n",
+	    login->s);
+	if (!fast) {
+		c->gid = pw->pw_gid;
+		c->uid = pw->pw_uid;
+		/*
+		 * Here we don't check the home and maildir path, if a user
+		 * has a faked passwd entry, then you have a bigger problem
+		 * on your system than just a guy how can read the mail of
+		 * other users/customers.
+		 */
+		if (!stralloc_copys(&c->home, pw->pw_dir))
+			return ERRNO;
+		if (!stralloc_0(&c->home))
+			return ERRNO;
+	
+		ret = get_local_maildir(&c->home, &c->maildir);
+		if (ret != 0)
+			return ret;
+		logit(32, "get_local_maildir: maildir=%s\n", c->maildir.s);
+	}
+
+#ifdef PW_SHADOW
+	spw = getspnam(login->s);
+	if (!spw)
+		/* XXX: again, temp hidden */
+		return FAILED;
+	ret = cmp_passwd((unsigned char*) authdata->s, spw->sp_pwdp);
+#else /* no PW_SHADOW */
+#ifdef AIX
+	spw = getuserpw(login->s);
+	if (!spw)
+		/* XXX: and again */
+		return FAILED;
+	ret = cmp_passwd((unsigned char*) authdata->s, spw->upw_passwd);
+#else /* no AIX */
+	ret = cmp_passwd((unsigned char*) authdata->s, pw->pw_passwd);
+#endif /* END AIX */
+#endif /* END PW_SHADOW */
+	logit(32, "check_pw: password compare was %s\n", 
+	    ret==OK?"successful":"not successful");
+	return ret;
+}
+
+
+int
+get_local_maildir(stralloc *home, stralloc *maildir)
+{
+	substdio	ss;
+	char		buf[512];
+	int		dirfd, fd, match, save;
+	
+	dirfd = open_read(".");
+	if (dirfd == -1)
+		return ERRNO;
+	if (chdir(home->s) == -1)
+		return ERRNO;
+
+	if ((fd = open_read(".qmail")) == -1) {
+		if (errno == error_noent) return 0;
+		return ERRNO;
+	}
+
+	substdio_fdbuf(&ss, subread, fd, buf, sizeof(buf));
+	while (1) {
+		if (getln(&ss, maildir, &match, '\n') != 0) goto tryclose;
+		if (!match && !maildir->len) {
+			if (!stralloc_copyb(maildir, "", 1)) goto tryclose;
+			break;
+		}
+		if ((maildir->s[0] == '.' || maildir->s[0] == '/') && 
+			  maildir->s[maildir->len-2] == '/') {
+			maildir->s[maildir->len-1] = '\0';
+			break;
+		}
+	}
+	if (fchdir(dirfd) == -1)
+		return ERRNO;
+	close(dirfd);
+	close(fd);
+	return 0;
+
+tryclose:
+	save = errno; /* preserve errno */
+	if (fchdir(dirfd) == -1)
+		return ERRNO;
+	close(dirfd);
+	close(fd);
+	errno = save;
+	return ERRNO;
+}
+
diff -ruN qmail-1.03-orig/locallookup.h qmail-1.03-ldap-20060201-orig/locallookup.h
--- qmail-1.03-orig/locallookup.h	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/locallookup.h	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,45 @@
+/*
+ * Copyright (c) 2003-2004 Claudio Jeker,
+ *      Internet Business Solutions AG, CH-8005 Zürich, Switzerland
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *      This product includes software developed by Internet Business
+ *      Solutions AG and its contributors.
+ * 4. Neither the name of the author nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+#ifndef __LOCALLOOKUP_H__
+#define __LOCALLOOKUP_H__
+
+#include "stralloc.h"
+
+struct credentials;
+
+int check_passwd(stralloc *, stralloc *, struct credentials *, int);
+int get_local_maildir(stralloc *, stralloc *);
+
+#endif
+
diff -ruN qmail-1.03-orig/lock.h qmail-1.03-ldap-20060201-orig/lock.h
--- qmail-1.03-orig/lock.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/lock.h	2006-02-25 11:00:55.000000000 +0100
@@ -1,8 +1,8 @@
 #ifndef LOCK_H
 #define LOCK_H
 
-extern int lock_ex();
-extern int lock_un();
-extern int lock_exnb();
+extern int lock_ex(int);
+extern int lock_un(int);
+extern int lock_exnb(int);
 
 #endif
diff -ruN qmail-1.03-orig/maildir2mbox.c qmail-1.03-ldap-20060201-orig/maildir2mbox.c
--- qmail-1.03-orig/maildir2mbox.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/maildir2mbox.c	2006-02-25 11:00:55.000000000 +0100
@@ -1,3 +1,7 @@
+#include <sys/types.h>
+#include <sys/stat.h>
+#include <stdio.h>
+#include <unistd.h>
 #include "readwrite.h"
 #include "prioq.h"
 #include "env.h"
@@ -33,7 +37,7 @@
 
 void die_nomem() { strerr_die2x(111,FATAL,"out of memory"); }
 
-void main()
+int main()
 {
  substdio ssin;
  substdio ssout;
@@ -73,8 +77,8 @@
  if (fdnewmbox == -1)
    strerr_die4sys(111,FATAL,"unable to create ",mboxtmp,": ");
 
- substdio_fdbuf(&ssin,read,fdoldmbox,inbuf,sizeof(inbuf));
- substdio_fdbuf(&ssout,write,fdnewmbox,outbuf,sizeof(outbuf));
+ substdio_fdbuf(&ssin,subread,fdoldmbox,inbuf,sizeof(inbuf));
+ substdio_fdbuf(&ssout,subwrite,fdnewmbox,outbuf,sizeof(outbuf));
 
  switch(substdio_copy(&ssout,&ssin))
   {
@@ -90,7 +94,7 @@
    fd = open_read(filenames.s + pe.id);
    if (fd == -1)
      strerr_die4sys(111,FATAL,"unable to read $MAILDIR/",filenames.s + pe.id,": ");
-   substdio_fdbuf(&ssin,read,fd,inbuf,sizeof(inbuf));
+   substdio_fdbuf(&ssin,subread,fd,inbuf,sizeof(inbuf));
 
    if (getln(&ssin,&line,&match,'\n') != 0)
      strerr_die4sys(111,FATAL,"unable to read $MAILDIR/",filenames.s + pe.id,": ");
@@ -105,7 +109,7 @@
 	}
        else
 	{
-	 int i;
+	 unsigned int i;
          if (!stralloc_ready(&ufline,line.len)) die_nomem();
          if (!stralloc_copys(&ufline,"From ")) die_nomem();
 	 for (i = 14;i < line.len - 2;++i)
@@ -158,5 +162,5 @@
      strerr_warn4(WARNING,"$MAILDIR/",filenames.s + pe.id," will be delivered twice; unable to unlink: ",&strerr_sys);
   }
 
- _exit(0);
+ return 0;
 }
diff -ruN qmail-1.03-orig/maildir.c qmail-1.03-ldap-20060201-orig/maildir.c
--- qmail-1.03-orig/maildir.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/maildir.c	2006-02-25 11:00:55.000000000 +0100
@@ -1,5 +1,6 @@
 #include <sys/types.h>
 #include <sys/stat.h>
+#include <unistd.h>
 #include "prioq.h"
 #include "env.h"
 #include "stralloc.h"
@@ -12,7 +13,7 @@
 struct strerr maildir_chdir_err;
 struct strerr maildir_scan_err;
 
-int maildir_chdir()
+int maildir_chdir(void)
 {
  char *maildir;
  maildir = env_get("MAILDIR");
@@ -28,32 +29,32 @@
 {
  DIR *dir;
  direntry *d;
- datetime_sec time;
+ datetime_sec tnow;
  struct stat st;
 
- time = now();
+ tnow = now();
 
  dir = opendir("tmp");
  if (!dir) return;
 
- while (d = readdir(dir))
+ while ((d = readdir(dir)))
   {
    if (d->d_name[0] == '.') continue;
    if (!stralloc_copys(tmpname,"tmp/")) break;
    if (!stralloc_cats(tmpname,d->d_name)) break;
    if (!stralloc_0(tmpname)) break;
    if (stat(tmpname->s,&st) == 0)
-     if (time > st.st_atime + 129600)
+     if (tnow > st.st_atime + 129600)
        unlink(tmpname->s);
   }
  closedir(dir);
 }
 
-static int append(pq,filenames,subdir,time)
+static int append(pq,filenames,subdir,tnow)
 prioq *pq;
 stralloc *filenames;
 char *subdir;
-datetime_sec time;
+datetime_sec tnow;
 {
  DIR *dir;
  direntry *d;
@@ -65,7 +66,7 @@
  if (!dir)
    STRERR_SYS3(-1,maildir_scan_err,"unable to scan $MAILDIR/",subdir,": ")
 
- while (d = readdir(dir))
+ while ((d = readdir(dir)))
   {
    if (d->d_name[0] == '.') continue;
    pos = filenames->len;
@@ -74,7 +75,7 @@
    if (!stralloc_cats(filenames,d->d_name)) break;
    if (!stralloc_0(filenames)) break;
    if (stat(filenames->s + pos,&st) == 0)
-     if (st.st_mtime < time) /* don't want to mix up the order */
+     if (st.st_mtime < tnow) /* don't want to mix up the order */
       {
        pe.dt = st.st_mtime;
        pe.id = pos;
@@ -94,15 +95,14 @@
 int flagcur;
 {
  struct prioq_elt pe;
- datetime_sec time;
- int r;
+ datetime_sec tnow;
 
  if (!stralloc_copys(filenames,"")) return 0;
  while (prioq_min(pq,&pe)) prioq_delmin(pq);
 
- time = now();
+ tnow = now();
 
- if (flagnew) if (append(pq,filenames,"new",time) == -1) return -1;
- if (flagcur) if (append(pq,filenames,"cur",time) == -1) return -1;
+ if (flagnew) if (append(pq,filenames,"new",tnow) == -1) return -1;
+ if (flagcur) if (append(pq,filenames,"cur",tnow) == -1) return -1;
  return 0;
 }
